Imports System.Runtime.InteropServices
Imports System.IO

Public Class clsCDBurn

    Private imapiCD As IMAPI_CDBurner.ICDBurn
    Private mbHasCDBurner As Boolean = False
    Private mstrDrive As String
    Private mstrBurnPath2 As String
    Private mstrBurnPath As String

    <DllImport("shell32.dll", entrypoint:="SHGetFolderPathW", _
           CallingConvention:=CallingConvention.StdCall)> _
    Private Shared Function SHGetFolderPath(ByVal hWnd As Integer, _
                              ByVal nFolder As Integer, ByVal nToken As Integer, _
                              ByVal dwFlags As Integer, _
                              <MarshalAs(UnmanagedType.LPTStr)> ByVal lpszPath As String) As Boolean
    End Function

    Public Sub New()
        Const CSIDL_CDBURN_AREA = &H3B

        Dim os As OperatingSystem

        os = Environment.OSVersion

        If os.Platform <> PlatformID.Win32NT And os.Version.Major < 5 _
            And os.Version.Minor < 1 Then
            Throw New Exception("Unsupported Operating System")
            Return
        End If

        Dim strPath As String = Space(260)
        If SHGetFolderPath(0, CSIDL_CDBURN_AREA, 0, 0, strPath) = 0 Then
            strPath = strPath.Trim
            strPath = strPath.Substring(0, strPath.Length - 1)
            mstrBurnPath = strPath + "\"
            mstrBurnPath2 = strPath
        End If

        imapiCD = New IMAPI_CDBurner.CDBurnClass
        Dim intDrives As Integer

        imapiCD.HasRecordableDrive(intDrives)
        mbHasCDBurner = intDrives > 0

        If Not mbHasCDBurner Then
            Throw New Exception("No CD Burner")
            Return
        End If

    End Sub


    Public Function AddFileToBurn(ByVal strFile As String) As Boolean
        Dim fl As System.IO.FileInfo
        Dim strPath As String

        Try
            fl = New System.IO.FileInfo(strFile)
            strPath = mstrBurnPath + fl.Name
            System.IO.File.Copy(strFile, strPath)
        Catch
            Return False
        End Try

        Return True
    End Function

    Public Sub Burn(ByVal hWnd As IntPtr)
        imapiCD.Burn(UInt32.Parse(hWnd.ToString))
    End Sub

    Function GetFolderSize(ByVal dPath As String, ByVal includeSubFolders As Boolean) As Long
        Dim abort As Boolean
        Try
            Dim size As Long = 0
            Dim diBase As New DirectoryInfo(dPath)
            Dim files() As FileInfo
            If includeSubFolders Then
                files = diBase.GetFiles("*", SearchOption.AllDirectories)
            Else
                files = diBase.GetFiles("*", SearchOption.TopDirectoryOnly)
            End If
            Dim ie As IEnumerator = files.GetEnumerator
            While ie.MoveNext And Not abort
                size += DirectCast(ie.Current, FileInfo).Length
            End While
            Return size
        Catch ex As Exception
            MsgBox("Error: " & ex.Message)
            Return -1
        End Try
    End Function

    Public Function CDBrun_size() As String '    cdbrun
        Return GetFolderSize(mstrBurnPath, True)
    End Function

    Public Function AddFolderToCDBrun(ByVal folder_path As String) As Boolean
        Dim fl As System.IO.DirectoryInfo
        Dim strPath As String

        Try
            fl = New System.IO.DirectoryInfo(folder_path)
            strPath = mstrBurnPath + fl.Name
            My.Computer.FileSystem.CopyDirectory(folder_path, strPath)
        Catch
            Return False
        End Try

        Return True
    End Function
    Public Function del_all_file_folder()
        Dim fso, fldr
        fso = CreateObject("Scripting.FilesystemObject")
        fldr = fso.GetFolder(mstrBurnPath2)
        '*******************
        'delete subfolders |
        '*******************
        For Each subf In fldr.SubFolders
            subf.Delete(True)
        Next
        '*****************
        'delete subfiles |
        '*****************
        For Each fsofile In fldr.Files
            fsofile.Delete(True)
        Next
    End Function

    Public Function del_all_files()
        Dim fso, fldr
        fso = CreateObject("Scripting.FilesystemObject")
        fldr = fso.GetFolder(mstrBurnPath2)
       
        For Each fsofile In fldr.Files
            fsofile.Delete(True)
        Next
    End Function

    Public Function del_all_folders()
        Dim fso, fldr
        fso = CreateObject("Scripting.FilesystemObject")
        fldr = fso.GetFolder(mstrBurnPath2)
       
        For Each subf In fldr.SubFolders
            subf.Delete(True)
        Next
    End Function

    Public Function del_File(ByVal file_path As String)
        System.IO.File.Delete(mstrBurnPath & file_path)
    End Function

    Public Function del_folder(ByRef folder_path As String)
        My.Computer.FileSystem.DeleteDirectory(mstrBurnPath & folder_path, FileIO.DeleteDirectoryOption.DeleteAllContents)
    End Function
End Class
